#include <mysql/mysql.h>
#include <stdlib.h>
#include <stdio.h>

#include "netmon_std.h"
#include "database_common.h"

int insert_db_row( struct db_conn *dbc, struct interface_line *il ) {
	
	while( 1 ) {
		snprintf( dbc->insert_space, BUFFER*8, 
			"insert into netmon "
			"( netmon_interface, "
			"netmon_ibytes, netmon_obytes, "
			"netmon_ipackets, netmon_opackets ) "
			"values "
			"('%s', %lu, %lu, %lu, %lu )",
			il->name, il->ibytes, il->obytes,
			il->ipackets, il->opackets );

		if( mysql_query( dbc->conn, dbc->insert_space ) ) {
			fprintf( stderr, "Execution error: %s\n",
				mysql_error( dbc->conn ) );
			return( EXIT_FAILURE );
		}

		il = il->next;
		if( il == NULL ) {
			return( EXIT_SUCCESS );
		}
	}

	return( EXIT_SUCCESS );
}

int setup_db( struct db_conn *dc ) {

	dc->conn = mysql_init(NULL);

	if( !mysql_real_connect( dc->conn, dc->server, \
		dc->user, dc->password, dc->database, 0, NULL, 0 ) ) {
		/**
		 * fprintf( stderr, "Sorry, could not connect to db: %s\n",
			mysql_error( conn ) );
		 */
		fprintf( stderr, "No DB connection setup: %s\n",
			mysql_error( dc->conn ) );
		return( EXIT_FAILURE );
	}

	dc->insert_space = (char *)malloc( BUFFER*8 );
	if( dc->insert_space == NULL ) {
		fprintf( stderr, "Not enough memory to allocate "
			"space for statement" );
		return( EXIT_FAILURE );
	}

	return( EXIT_SUCCESS );
}

/*
int main() {
	return( EXIT_SUCCESS );
} */

